package com.template.controller;


import com.template.api.SmartMeterDetailControllerAPI;

import com.template.common.utils.paramUtils;
import com.template.model.pojo.SmartMeterDetail;
import com.template.model.pojo.SmartMeterDetail;
import com.template.model.result.CommonResult;
import com.template.model.result.PageUtils;
import com.template.services.SmartMeterDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-12-04
 */
@RestController
public class SmartMeterDetailController implements SmartMeterDetailControllerAPI {

    @Autowired
    private SmartMeterDetailService smartMeterDetailService;

    /**
     * 新增水电表能耗明细
     * @param smartApply 水电表能耗明细数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult insertSmartMeterDetail(SmartMeterDetail smartApply, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartMeterDetailService.insertSmartMeterDetail(smartApply);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新水电表能耗明细
     * @param sa 水电表能耗明细数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult updateSmartMeterDetailById(SmartMeterDetail sa, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartMeterDetailService.updateSmartMeterDetail(sa);
        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 水电表能耗明细分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageSmartMeterDetails(int currentPage, int pageCount, String name) {
        PageUtils<SmartMeterDetail> result = smartMeterDetailService.queryPageSmartMeterDetails(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }


    @Override
    public CommonResult deleteSmartMeterDetailById(int id) {

        SmartMeterDetail data = smartMeterDetailService.getSmartById(id);

        if(data == null){
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = smartMeterDetailService.deleteSmartMeterDetailById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

